• 面试题 31: 求子数组的最大和


    题目:输入一个整形数组,数组里有正数也有负数。数组中连续的一个或多个整数组成一个子数组,每个子数组都有一个和。求所有子数组的和的最大值。要求时间复杂度为O(n)

    例如输入的数组为1, -2, 3, 10, -4, 7, 2, -5,和最大的子数组为3, 10, -4, 7, 2,因此输出为该子数组的和18

    分析:本题最初为2005年浙江大学计算机系的考研题的最后一道程序设计题,在2006年里包括google在内的很多知名公司都把本题当作面试题。由于本题在网络中广为流传,本题也顺利成为2006年程序员面试题中经典中的经典。

    如果不考虑时间复杂度,我们可以枚举出所有子数组并求出他们的和。不过非常遗憾的是,由于长度为n的数组有O(n2)个子数组;而且求一个长度为n的数组的和的时间复杂度为O(n)。因此这种思路的时间是O(n3)

    很容易理解,当我们加上一个正数时,和会增加;当我们加上一个负数时,和会减少。如果当前得到的和是个负数,那么这个和在接下来的累加中应该抛弃并重新清零,不然的话这个负数将会减少接下来的和。基于这样的思路,我们可以写出如下代码。

    我想这道题目就是杭电的 hdu 1003 Max Sum . 所以我就索性再写一遍杭电的 1003;  动态规划 

    #include <iostream>
    #include <string>
    #include <cstring>
    #include <cstdlib>
    #include <cstdio>
    #include <cmath>
    #include <vector>
    #include <stack>
    #include <deque>
    #include <queue>
    #include <bitset>
    #include <list>
    #include <map>
    #include <set>
    #include <iterator>
    #include <algorithm>
    #include <functional>
    #include <utility>
    #include <sstream>
    #include <climits>
    #include <cassert>
    #define BUG puts("here!!!");
    
    using namespace std;
    
    int main() {
    	int T;
    	scanf("%d", &T);
    	int n, temp, s, f, i, v, sum = 0, maxn;
    	for(int e = 1; e <= T; e++) {
    		int n, temp, s, f, i, v, sum = 0;
    		maxn = 0x80000000;
    		scanf("%d", &n);
    		for(temp = 1, i = 1; i <= n; i++) {
    			scanf("%d", &v);
    			sum += v;
    			if(sum > maxn) {
    				maxn = sum;
    				s = temp;
    				f = i;
    			}
    			if(sum < 0) {
    				temp = i+1;
    				sum = 0;
    			}
    		}
    		printf("Case %d:\n%d %d %d\n", e, maxn, s, f);
    		if(e < T) printf("\n");
    	}
    	return 0;
    }

  • 相关阅读:
    hdu4276 依赖背包
    poj1155 依赖背包
    cf219d 基础换根法
    贪婪大陆——(树状数组)
    数星星(树状数组或者线段树)
    拓扑排序基础题——排序
    Codeforces Round #511 (Div. 1) T2 Little C Loves 3 II
    除虫药水(简单dp)
    烽火传递(单调队列优化dp,然而蒟蒻用一个优先队列做)
    ZOJ----3471Most powerful(简单状压dp)
  • 原文地址:https://www.cnblogs.com/robbychan/p/3787150.html
Copyright © 2020-2023  润新知